' Pollin Spiel T2313 mit Blitz-Empfnger an T0 und Standby
 Data "P o l l i n - T 2 3 1 3  G e w i t t e r D e t e c t o r"
' der Name ist im Klartext immer lesbar!
'###############################################################################
'  1 /Reset/ISP6      R1=10k                 10k
'  2 D0/Rx/T1/LED1    R6=150/R7=33k          (Rx) frei
'  3 D1/Tx/T2/LED2    R8=150/R9=33k          (Tx) frei
'  4 A1/Xtal/LCD_RS                          LCD
'  5 A0/Xtal/LCD_E                           LCD
'  6 D2/Int0/T_On     R5=33k                 frei
'  7 D3/Int1/T3/LED3  R10=150/R11=33k        frei
'  8 D4/T0/T4/LED4    R12=150/R13=33k        Eingang vom Empfnger
'  9 D5/T1/oc0b/Buzz  R4=150/R14=1k/Tr1/D1   optische/akustische Anzeige
' 10 GND/ISP10+8+6                           GND
' 11 D5/ICP/LCD_Vdd                          LCD
' 12 B0/Ain0/LCD_DB4                         LCD
' 13 B1/Ain1/LCD_DB5                         LCD
' 14 B2/oc0a/LCD_DB6                         LCD
' 15 B3/oc1a/LCD_DB7                         LCD
' 16 B4/oc1b/LCD_Vo   R3=56/R2=10k           LCD kann frei gemacht werden
' 17 B5/SDA/mosi/ISP1                        frei
' 18 B6/Do/miso/ISP9                         frei
' 19 B7/SCL/SCK/ISP7                         frei
' 20 +5Vcc/ISP2       C1                     +5V
'###############################################################################
Led1 Alias Portd.0 : T1 Alias Pind.0
Led2 Alias Portd.1 : T2 Alias Pind.1
T_on Alias Pind.2
Led3 Alias Portd.3 : T3 Alias Pind.3
Led4 Alias Portd.4 : T4 Alias Pind.4
Buzz Alias Portd.5

$regfile = "attiny2313.dat"
$crystal = 1000000
$hwstack = 32                                          '32
$swstack = 32                                          '8
$framesize = 32                                        '24
'$lib "mcsbyte.lbx"
'$baud = 19200
Const Empfangen = 1                                    'Senden-Empfangen Umschalter

Ddra = &B00000011 : Ddrb = &B00001111 : Ddrd = &B01101000 : Portd.6 = 1       'lCD=on
Buzz = 1                                               'Buzz
Led3 = 1                                               'Speisung Receiver max 10mA
Led4 = 1                                               'T0 pullup
                                           '
Config Timer0 = Counter , Edge = Falling
Config Lcd = 16 * 2 , Chipset = Ks077                  'Config Lcdbus = 4
Config Lcdpin = Pin , Db4 = Portb.0 , Db5 = Portb.1 , Db6 = Portb.2 , Db7 = Portb.3 , E = Porta.0 , Rs = Porta.1
Initlcd : Cls

Dim Blitze As Word                                     'display
Dim Musik As Byte
Dim Temp As Byte
Dim Text As String * 8
Dim Zeit As Byte                                       'fr entladen
Dim Zeit2 As Byte                                      'fr standby

Const Gelb = 1000 :                                    'fern
Const Rot = 2000 :                                     'mittel
Const Rotrot = 4000                                    'nah
Const Totzeit = 1000                                   'Anzeigezeit
Const Entladzeit = 1                                   't=entladen*totzeit
Const Entladwert = 1                                   'Entlade-Wert
Const Onzeit = 100                                     '100s
Const Offzeit = 600                                    '600s=10min

Locate 1 , 1 : Lcd "Blitz-  " : Locate 2 , 1 : Lcd "Detector" : Wait 2 : Locate 1 , 1 : Lcd "        "

Do
#if Empfangen
'intgrieren
   Waitms Totzeit : Temp = Timer0 : Timer0 = 0 : Blitze = Blitze + Temp

'anzeigen
   Locate 1 , 1 : Lcd "BL " : Lcd Blitze : Lcd "       "
   If Blitze <= Gelb Then : Text = "LE GRUEN" : Musik = 15 : End If
   If Blitze > Gelb Then : Text = "LE GELB " : Musik = 100 : End If
   If Blitze > Rot Then : Text = "LE  ROT " : Musik = 75 : End If
   If Blitze > Rotrot Then : Text = " GEFAHR " : Musik = 60 : End If
   Locate 2 , 1 : Lcd Text
   If Temp > 0 Then Sound Buzz , 32 , Musik            'optisch/akustisch
   Buzz = 1                                            'LED/Buzz aus
   If Blitze > 65000 Then Blitze = 65000               'Fehlerbehandlung

'entladen
   If Zeit = Entladzeit Then
      If Blitze >= Entladwert Then Blitze = Blitze - Entladwert
      Zeit = 0
   Else
      Incr Zeit
   End If
'einschlafen?
   If Blitze = 0 Then
      If Zeit2 = Onzeit Then Gosub Sub_schlaf Else Zeit2 = Zeit2 + 1
   End If
#else                                                  'Impuls-Sender ber Buzz
'   Wait 2 : For Blitze = 1 To 5 : Buzz = 0 : Waitus 50 : Buzz = 1 : Waitms 50 : Next Blitze
'   Wait 2 : For Blitze = 1 To 5 : Buzz = 1 : Waitus 50 : Buzz = 0 : Waitms 50 : Next Blitze
#endif
Loop
'-------------------------------------------------------------------------------
Sub_schlaf:
   Ddra = 0 : Ddrb = 0 : Ddrd = 0 : Porta = 0 : Portb = 0 : Portd = 0       'lCD=off
   Wait Offzeit

   Ddra = &B00000011 : Ddrb = &B00001111 : Ddrd = &B01101000 : Portd.6 = 1       'lCD=on
   Initlcd : Cls
   Buzz = 1                                            'Buzz
   Led3 = 1                                            'Speisung Receiver max 10mA
   Led4 = 1                                            'T0 pullup
   Zeit2 = 0
   Timer0 = 0
Return